//+------------------------------------------------------------------+
//|                                            HMA_RB_EA_V1.mq4      |
//|                            Rogrio Borges, Copyright 2016        |
//|                                          rogeriob28@gmail.com    | 
//+------------------------------------------------------------------+
#property copyright "Rogerio Borges,Copyright 2016"
#property link      "rogeriob28@gmail.com"
// You Need Custom Indicator named <HMA Color nrp>.

extern string Comentario = "HMA Color nrp STC EA v1 ";
//extern int    MagicNumber = 123456;  // Magic number to use for the EA
extern bool   EcnBroker   = false;   // Is your broker ECN/STP type of broker?
extern double LotSize     = 1;     // Lot size to use for trading
extern int    Slippage    = 1;       // Slipage to use when opening new orders
extern double StopLoss    = 10;     // Initial stop loss (in pips)
extern double TakeProfit  = 10;     // Initial take profit (in pips)
extern string EA_Texto4                = "==== Fechamento de Ordens ====";
extern bool UsarTPVirtual              = false;
extern float   TPVirtual               = 5; 
extern string EA_Texto8a               = "==== Trailing Stop ====";
extern bool UsarTrailingStop           = true;
extern int     TrailingStop = 2;
extern string dummy1      = "";      // .
extern string dummy2      = "";      // Settings for indicators
extern int    BarToUse    = 1;       // Bar to test (0, for still opened, 1 for first closed, and so on)
extern string     IndicatorsSettings   = "===== INDICATORS SETTINGS=====";
extern string     _Indicator           = "===== HMA color nrp =====";
extern int        HMA_Period           = 20;
extern int        HMA_PriceType        = 0;
extern int        HMA_Method           = 3;
extern bool       alertsOn             = false;
extern bool       alertsOnCurrent      = false;
extern bool       alertsMessage        = false;
extern bool       alertsSound          = false;
extern bool       alertsEmail          = false;
extern string PARAMETERS_INDICATOR_TWO = "Stochastic";
extern int KPeriod=14;
extern int DPeriod=5;
extern int Slowing=5;

extern string dummy3      = "";      // . 
extern string dummy4      = "";      // General settings
extern bool   DisplayInfo = true;    // Dislay info

bool dummyResult;
double ponto;
extern int      MagicNumber = 1234567;
extern bool     AutoMagic = TRUE;//Generate Magic Number based on Symbol and Long/Short params
bool     TradeLong  = TRUE; 
bool     TradeShort = TRUE; 
int      MagicNumber_Old;
bool     AutoMagic_Old;
bool     TradeLong_Old;
bool     TradeShort_Old;
int     F_MA_TimeFrame=0;
//EA name
string  EANAME="HmaStc";
string  EASHORTNAME="HmaStc";
int    digit = 0;
double PointRatio = 1;
double myPoint;
string s_symbol;
bool diStcBuy = false;
bool diStcSell = false;
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()   
{ 
AutoMagic();//Done here for immediate update
    //Calculo de Ponto
   if (Point == 0.00001) ponto = 0.0001;
   else {
      if (Point == 0.001) ponto = 0.01;
      else ponto = Point;
   }
//novo cauculo de ponto
   s_symbol = Symbol();
   digit  = MarketInfo(s_symbol,MODE_DIGITS);
   if (digit==2 || digit==4) PointRatio = 1;
   if (digit==3 || digit==5) PointRatio = 10;
   if (digit==6)             PointRatio = 100;
   myPoint  = MarketInfo(s_symbol,MODE_POINT) * PointRatio; 
return(0); 
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

#define _doNothing 0
#define _doBuy     1
#define _doSell    2
int start()
{
   //MagicWarning();//Display a warning in case MagicNumber is changed
   AutoMagic();//Generate Magic Number based on Symbol and Long/Short params
   
   int doWhat = _doNothing;
      double diStochasticB1=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_EMA,PRICE_CLOSE,MODE_MAIN,0);
      double diStochasticB2=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_EMA,PRICE_CLOSE,MODE_SIGNAL,0);
      double diStochasticS1=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_EMA,PRICE_CLOSE,MODE_MAIN,0);
      double diStochasticS2=iStochastic(NULL,0,KPeriod,DPeriod,Slowing,MODE_EMA,PRICE_CLOSE,MODE_SIGNAL,0);
      
       
      double hma_trend_current  = iCustom(NULL, 0, "HMA Color nrp", HMA_Period, HMA_PriceType, HMA_Method,6,BarToUse);
      double hma_trend_previous = iCustom(NULL, 0, "HMA Color nrp", HMA_Period, HMA_PriceType, HMA_Method,6,BarToUse+1);
      
      if (diStochasticB1>diStochasticB1){
          diStcBuy = true;
                  
      }

      if (diStochasticS1<diStochasticS2){
          diStcSell = true;
      }
      
      if (hma_trend_current!=hma_trend_previous)
         if (hma_trend_current==1)
               doWhat = _doBuy;
         else  doWhat = _doSell;
         if (doWhat==_doNothing && !DisplayInfo) return(0);
         
   //
   //
   //
   //
   //
  
   int    openedBuys    = 0;
   int    openedSells   = 0;
   double currentProfit = 0;
   if(UsarTrailingStop) TrailingStoprb(); //TrailingStop();
      
   ModifyOrders();
   for (int i = OrdersTotal()-1; i>=0; i--)
   {
      if (!OrderSelect(i,SELECT_BY_POS,MODE_TRADES)) continue;
      if (OrderSymbol()      != Symbol())            continue;
      if (OrderMagicNumber() != MagicNumber)         continue;

      //
      //
      //
      //
      //
      
      if (DisplayInfo) currentProfit += OrderProfit()+OrderCommission()+OrderSwap();
         
         //
         //
         //
         //
         //
         
         if (OrderType()==OP_BUY)
            if (doWhat==_doSell && diStcSell==true)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Bid,Slippage,Orange)) openedBuys++; }
            else  openedBuys++;
         if (OrderType()==OP_SELL)
            if (doWhat==_doBuy & diStcBuy==true)
                  { RefreshRates(); if (!OrderClose(OrderTicket(),OrderLots(),Ask,Slippage,Green)) openedSells++; }
            else  openedSells++;            
   }
   if (DisplayInfo) Comment("Current profit : "+DoubleToStr(currentProfit,2)+" "+AccountCurrency()); if (doWhat==_doNothing) return(0);

   //
   //
   //
   //
   //

   if (doWhat==_doBuy && diStcBuy==true && openedBuys==0)
      {
         RefreshRates();
         //double BStopLossLevel   = Ask - StopLoss   *myPoint;
         //double BTakeProfitLevel = Ask + TakeProfit *myPoint;               
         double stopLossBuy   = 0; if (StopLoss>0)   stopLossBuy   =Ask - StopLoss   *myPoint; //Ask-StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitBuy = 0; if (TakeProfit>0) takeProfitBuy =Ask + TakeProfit *myPoint; //Ask+TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int ticketb = OrderSend(Symbol(),OP_BUY,LotSize,NormalizeDouble(Ask,digit),Slippage*myPoint,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_B",MagicNumber,0,Blue);
            if (ticketb>-1)
               dummyResult = OrderModify(ticketb,OrderOpenPrice(),NormalizeDouble(stopLossBuy,digit),NormalizeDouble(takeProfitBuy,digit),0,CLR_NONE);
              
              
         }
         else dummyResult = OrderSend(Symbol(),OP_BUY,LotSize,NormalizeDouble(Ask,digit),Slippage*myPoint,NormalizeDouble(stopLossBuy,digit),NormalizeDouble(takeProfitBuy,digit),EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_B",MagicNumber,0,Blue);
          
      }
   if (doWhat==_doSell && diStcSell==true && openedSells==0)
      {
         RefreshRates();
         //double SStopLossLevel   = Bid + StopLoss   *Mypoint;
         //double STakeProfitLevel = Bid - TakeProfit *Mypoint;
         double stopLossSell   = 0; if (StopLoss>0)   stopLossSell=Bid + StopLoss   *myPoint; //Bid+StopLoss*Point*MathPow(10,Digits%2);
         double takeProfitSell = 0; if (TakeProfit>0) takeProfitSell =Bid - TakeProfit *myPoint; //Bid-TakeProfit*Point*MathPow(10,Digits%2);
         if (EcnBroker)
         {
            int tickets = OrderSend(Symbol(),OP_SELL,LotSize,NormalizeDouble(Bid,digit),Slippage*myPoint,0,0,EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Red);
            if (tickets>-1)
                dummyResult = OrderModify(tickets,OrderOpenPrice(),NormalizeDouble(stopLossSell,digit),NormalizeDouble(takeProfitSell,digit),0,CLR_NONE);
         }
         
         else dummyResult = OrderSend(Symbol(),OP_SELL,LotSize,NormalizeDouble(Bid,digit),Slippage*myPoint,NormalizeDouble(stopLossSell,digit),NormalizeDouble(takeProfitSell,digit),EASHORTNAME+"_"+Symbol()+"("+GetChartTimeFrame()+")_S",MagicNumber,0,Red);
      }
   return(0);
}

// ------ Modificar ordens

void ModifyOrders()
{ 
static int ticket;
    for (int i = 0; i < OrdersTotal(); i++) {
     OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
     double stopLossPreco = OrderStopLoss();
     double sl = OrderStopLoss();
     double tp = OrderTakeProfit();
              
     if ( OrderSymbol()==Symbol() && OrderMagicNumber() == MagicNumber ) 
        {
        
        //TP virtual
        if (UsarTPVirtual) {
          if (OrderType() == OP_BUY) {
                          if (Bid - OrderOpenPrice() >= (TPVirtual * ponto)) {
                          OrderClose(OrderTicket(),OrderLots(),Bid,3,Yellow); } 
                          RefreshRates();
                          }
          if (OrderType() == OP_SELL) {
            if (OrderOpenPrice()- Ask >= TPVirtual * ponto) {
                            OrderClose(OrderTicket(),OrderLots(),Ask,3,Yellow); }
                            RefreshRates();
          
          }
            }
            //End TP virtual
             
          
               
                 
        
             
          
}         
}   
   
} //End ModifyOrders


//---------------- AutoMagic --------------------------
void AutoMagic() {
   if( !AutoMagic ) return(0);//Magic Number will be set manually
   //AutoMagicNumbers has the format: 9999XXY
   string   MagAutoApp = "00";//MagicAutoAppendage   
   if(Symbol() == "EURUSD"){
      MagAutoApp = "01";// !! "00" is reserved for Symbol not found !!
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDCHF"){
      MagAutoApp = "02";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDJPY"){
      MagAutoApp = "03";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPUSD"){
      MagAutoApp = "04";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDUSD"){
      MagAutoApp = "05";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDCAD"){
      MagAutoApp = "06";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURGBP"){
      MagAutoApp = "07";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURCHF"){
      MagAutoApp = "08";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURJPY"){
      MagAutoApp = "09";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPJPY"){
      MagAutoApp = "10";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "GBPCHF"){
      MagAutoApp = "11";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURCAD"){
      MagAutoApp = "12";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURAUD"){
      MagAutoApp = "13";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDSGD"){
      MagAutoApp = "14";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "NZDUSD"){
      MagAutoApp = "15";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CHFJPY"){
      MagAutoApp = "16";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "EURNZD"){
      MagAutoApp = "17";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDJPY"){
      MagAutoApp = "18";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDNZD"){
      MagAutoApp = "19";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDCAD"){
      MagAutoApp = "20";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "AUDCHF"){
      MagAutoApp = "21";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CADCHF"){
      MagAutoApp = "22";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "CADJPY"){
      MagAutoApp = "23";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "NZDJPY"){
      MagAutoApp = "24";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDDKK"){
      MagAutoApp = "25";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDNOK"){
      MagAutoApp = "26";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDSEK"){
      MagAutoApp = "27";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "USDHKD"){
      MagAutoApp = "28";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
   if(Symbol() == "SGDJPY"){
      MagAutoApp = "29";
      if(!TradeLong && !TradeShort) MagAutoApp = MagAutoApp + "0";//None
      if(TradeLong  && !TradeShort) MagAutoApp = MagAutoApp + "1";//Long
      if(!TradeLong &&  TradeShort) MagAutoApp = MagAutoApp + "2";//Short
      if(TradeLong  &&  TradeShort) MagAutoApp = MagAutoApp + "3";//Long + Short
      }
      
   if(MagAutoApp == "00" ) {//Symbol not found
      //------------------- Magic Warning Message -----------------------------------------------------------------------
      int   ButtonClicked = MessageBox("Could not generate Automatic MagicNumber for Symbol " + Symbol()
                           +"\n"+"reverting to default MagicNumber."
                           +"\n"+"You MUST disable AutoMagic, and set MagicNumber manually !"
                           +"\n"+""
                           +"\n"+"  ", "CAUTION !          " + Symbol(), MB_OK|MB_ICONEXCLAMATION);
      //-----------------------------------------------------------------------------------------------------------------
      return(0);
      }
MagicNumber = StrToInteger("9999"+MagAutoApp);//AutoMagicNumbers has the format: 9999XXY
return (0);
}
//-----------------------------------------------------

//---------------- MagicWarning -----------------------
void MagicWarning() {
   if(   (MagicNumber != MagicNumber_Old) 
         || (AutoMagic != AutoMagic_Old)
         || (TradeLong != TradeLong_Old)
         || (TradeShort != TradeShort_Old)  )   
      {//Changes were made that could result in a new MagicNumber...      
      //------------------- Magic Warning Message -----------------------------------------------------------------------
      int   ButtonClicked = MessageBox("Changing the MagicNumber or AutoMagic parameters, or changing the TradeLong or TradeShort " 
                           +"\n"+"parameters while AutoMagic is enabled, WILL result in a new MagicNumber !"
                           +"\n"+"All open orders WILL become orphan orders, and will have to be dealt with manually !!"
                           +"\n"+""
                           +"\n"+"  ", "CAUTION !          " + Symbol(), MB_OK|MB_ICONEXCLAMATION);
      //-----------------------------------------------------------------------------------------------------------------
      }   
   //Update the references:
   MagicNumber_Old = MagicNumber;
   AutoMagic_Old = AutoMagic;
   TradeLong_Old = TradeLong;
   TradeShort_Old = TradeShort;
return (0);
}
//-----------------------------------------------------



//+------------------------------------------------------------------+
//| Culculate Current Open Position                                  |
//+------------------------------------------------------------------+
int CalculateCurrentOrders()
{
   //Open Positionsi+:Buy -:Sellj
   int i;
   int pos=0;

   // Buy Position
   int pos_buy=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if(OrderType() == OP_BUY) pos_buy++ ;
      }
   }

   //Sell Position
   int pos_sell=0;
   for(i=0; i<OrdersTotal(); i++)
   {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES) == false) break;
      if(OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber)
      {
         if(OrderType() == OP_SELL) pos_sell--;
      }
   }

   //Culculate pos
   if(pos_buy>0) pos = pos_buy;
   if(pos_sell<0) pos = pos_sell;
   if(pos_sell == 0 && pos_buy == 0) pos = 0;

   return(pos);
} // end of CalculateCurrentOrders

//+------------------------------------------------------------------+
//| Get Current StopLoss                                             |
//+------------------------------------------------------------------+
double CheckCurrentStop()
{
   int pos,i;
   double CurrentSL;
   bool selected;
   
   pos = CalculateCurrentOrders();

   if(pos>0) // Buy
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }
   
   if(pos<0) // Sell
   {
      // Get Current StopLoss
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
            CurrentSL = OrderStopLoss();
         }
      }
   return(CurrentSL);
   }   
} // end of CheckCurrentStop


//+------------------------------------------------------------------+
//| TrailingStopScalp                                           |   
//+------------------------------------------------------------------+
void TrailingStoprb()
{
   int pos,i;
   double STOP, CurrentSL, STOP_HABA, Profit;
   bool selected;
   double stopLossPreco = OrderStopLoss();

   pos = CalculateCurrentOrders();
     

if(pos > 0) //Buy Position ------------------------------------------------------------------------------
{
      
      // Modify Stop Loss (Buy)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_BUY)
         {
           if (Bid - OrderOpenPrice() > TrailingStop * ponto) { 
                              if (OrderStopLoss() < Bid - (TrailingStop * ponto)){
                                 ResetLastError();
                                 OrderModify(OrderTicket(), OrderOpenPrice(), (Bid - (TrailingStop * ponto)), OrderTakeProfit(), 0, Blue);     
                                                                    
                              }  
                           } 
            
         }
      }
   return(0);
   

   

} // end of Buy Trailing --------------------------------------------------------------------------------

if(pos < 0) //Sell Position
{
   

      // Modify Stop Loss (Sell)
      for(i=0; i<OrdersTotal(); i++)
      {
         selected = OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(selected && OrderMagicNumber() == MagicNumber && OrderSymbol() == Symbol() && OrderType() == OP_SELL)
         {
           if (OrderOpenPrice()-Ask > TrailingStop*ponto) { 
                              if (OrderStopLoss()>Ask+TrailingStop*ponto || OrderStopLoss()==0){  
                                  ResetLastError();
                                  OrderModify(OrderTicket(), OrderOpenPrice(),(Ask + (TrailingStop*ponto)), OrderTakeProfit(), 0, Red);
                                     
                               }
                           }
            
         }
      }
   return(0);
   

   

} // end of Sell Trailing --------------------------------------------------------------------------------

} // end of TrailingStopScalp()

//+------------------------------------------------------------------+
//| GetChartTimeFrame                                                |
//+------------------------------------------------------------------+
string GetChartTimeFrame()
{   
   //ChartTimeFrame
   string TimeFrame ;
   switch(Period())
   {
      case 1:     TimeFrame = "M1";break;
      case 5:     TimeFrame = "M5"; break;
      case 15:    TimeFrame = "M15"; break;
      case 30:    TimeFrame = "M30"; break;
      case 60:    TimeFrame = "H1"; break;
      case 240:   TimeFrame = "H4"; break;
      case 1440:  TimeFrame = "D1";  break;
      case 10080: TimeFrame = "W1"; break;
      case 43200: TimeFrame = "MN1"; break;
   }
   return(TimeFrame);
}

//+------------------------------------------------------------------+
//| Select Fiter Time Frame                                          |
//+------------------------------------------------------------------+
string SelectTimeFrame(int TIMEFRAME)
{   
   //FilterTimeFrame
   string TimeFrame ;
   switch(TIMEFRAME)
   {
      case 1: TimeFrame = "PERIOD_M1"; break;
      case 2: TimeFrame = "PERIOD_M5"; break;
      case 3: TimeFrame = "PERIOD_M15"; break;
      case 4: TimeFrame = "PERIOD_M30"; break;
      case 5: TimeFrame = "PERIOD_H1"; break;
      case 6: TimeFrame = "PERIOD_H4"; break;
      case 7: TimeFrame = "PERIOD_D1";  break;
      default: F_MA_TimeFrame = 0 ;  break;
   }

   if(F_MA_TimeFrame==0)
   {
      switch(Period())
      {
         case 1:     TimeFrame = "PERIOD_M1";break;
         case 5:     TimeFrame = "PERIOD_M5"; break;
         case 15:    TimeFrame = "PERIOD_M15"; break;
         case 30:    TimeFrame = "PERIOD_M30"; break;
         case 60:    TimeFrame = "PERIOD_H1"; break;
         case 240:   TimeFrame = "PERIOD_H4"; break;
         case 1440:  TimeFrame = "PERIOD_D1";  break;
      }
   }
   
   return(TimeFrame);
}